<?php
/*******************************************************************************

    Author ......... Jimmy Conner
    Contact ........ jimmy@sqmail.org
    Home Site ...... http://sqmail.org
    Program ........ Monitoring for Cacti
    Version ........ 0.1
    Purpose ........ Simple Whats-Up-Gold replacement

*******************************************************************************/

chdir('../../');
include("./include/auth.php");

/* Alot of this code was taken from the Threshold module, and build upon / modified / hacked / etc... */


$sound = true;
// Check to see if we just turned on/off the sound via the button
if (isset($_POST['sound'])) {
	if ($_POST['sound'] == 'off') {
		setcookie("sound", 'off');
		$sound = false;
	} else {
		setcookie("sound", 'on');
		$sound = true;
	}
}

// Check to see if we turned off the sound before
if (isset($_COOKIE['sound']) && $_COOKIE['sound'] == 'off' && $_COOKIE['sound'] != '') {
	$sound = false;
}

// Check to see if a host is down
$host_down = false;
$sql = "SELECT description, id, status, disabled FROM host where status < 2 and disabled = '' and monitor = 'on'";
$result = mysql_query($sql) or die (mysql_error());
$chosts = array();

// do a quick loop through to pull the hosts that are down
while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	$host_down = true;
	$chosts[] = $row['id'];
	sort($chosts);
}

if (!$host_down) {
	setcookie("sound", 'on');
	$sound = true;
} else {
	// Check the cookie to see if we had any down hosts before
	if (isset($_COOKIE['hosts_down'])) {
		$dhosts = explode(',',$_COOKIE['hosts_down']);
		$x = count($dhosts);
		$y = count($chosts);

		if ($x != $y && $x < $y) {
			// We have more down hosts than before
			$sound = true;
			setcookie("sound", 'on');
			setcookie("hosts_down",implode(',',$chosts));
		} elseif ($x > $y) {
			// We have less down hosts than before
			// Need to check here to make sure that one didn't come on line and others go off
			setcookie("hosts_down",implode(',',$chosts));
		} else {
			// We have the same number of hosts, so loop through and make sure they are the same ones
			// These arrays are already sorted, so we don't need to worry about doing a real compare
			for ($a = 0; $a < $x; $a++) {
				if ($dhosts[$a] != $chosts[$a]) {
					$sound = true;
					setcookie("sound", 'on');
					setcookie("hosts_down",implode(',',$chosts));
					break;
				}
			}
		}
	} else {
		setcookie("hosts_down",implode(',',$chosts));		
	}
}


include("./include/top_graph_header.php");

// Display the Current Time
print "<center>Last Refresh : " . date("g:i:s a", time()) . '</center><br>';

// If the sound is on, and a host is down, show the button to silence it
if ($sound && $host_down)
	print "<center><form action='monitor.php' method=POST><input type=hidden name=sound value='off'><input type=image name='button_nosound' src='images/button_nosound.gif' alt='Turn off the alarm' border='0' align='absmiddle' action='submit' value='refresh'></center><br>";

if (!$sound && $host_down)
	print "<center><b>Alerting has been disabled by the client!</b></center><br>";

print "<center><table width='100%' cellspacing=3>\n";

// Create the status array (0=unknown, 1=down, 2=recovering, 3=up)
$icolors = array('red.gif','red.gif','blue.gif','green.gif');


$sql = "SELECT description, status, hostname FROM host where disabled = '' and monitor = 'on' ORDER BY description";

$result = mysql_query($sql) or die (mysql_error());

$x = 0;
while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
	// Loop through each host one by one
	$name = $row['description'];
	$status = $row['status'];
	$hostname =  $row['hostname'];

	if ($x == 0) {
		// If we are the the beginning of a row, start the row
		print "<tr>";
	}
	$i = $icolors[$status];
        $s = $s2 = '';
	if ($status < 2) {
		// If the host is down, we bold the name
		$s = '<b>';
		$s2 = '</b>';
	}
	print "<td valign=top><center><img src='images/$i' name='$name' id='$name' alt='IP Address: $hostname'><br>$s$name$s2</center></td>\n";

	$x++;
	if ($x == 10) {
		// After 10 items, end the row and start over
		print '</tr>';
		$x = 0;
	}
}

// If we didn't close the table row above, do so now
if ($x != 0)
	print '</tr>';
print "</table></center>";

// If the host is down, we need to insert the embedded wav file
if ($host_down && $sound)
	print '<EMBED src="images/attn-noc.wav" autostart=true loop=true volume=100 hidden=true><NOEMBED><BGSOUND src="images/attn-noc.wav"></NOEMBED>';

?>