<?php
/*******************************************************************************

    Author ......... Jimmy Conner
    Contact ........ jimmy@sqmail.org
    Home Site ...... http://sqmail.org
    Program ........ Monitoring for Cacti
    Version ........ 0.1
    Purpose ........ Simple Whats-Up-Gold replacement

*******************************************************************************/

function plugin_init_monitor() {
	global $plugin_hooks;
	$plugin_hooks['top_header_tabs']['monitor'] = 'monitor_show_tab';
	$plugin_hooks['top_graph_header_tabs']['monitor'] = 'monitor_show_tab';
	$plugin_hooks['config_arrays']['monitor'] = 'monitor_config_arrays';
	$plugin_hooks['draw_navigation_text']['monitor'] = 'monitor_draw_navigation_text';
	$plugin_hooks['config_form']['monitor'] = 'monitor_config_form';
	$plugin_hooks['api_device_save']['monitor'] = 'monitor_api_device_save';
}

function monitor_show_tab() {
	global $config;
	print '<a href="' . $config['url_path'] . 'plugins/monitor/monitor.php"><img src="' . $config['url_path'] . 'plugins/monitor/images/tab_monitor.gif" alt="Monitor" align="absmiddle" border="0"></a>';
	monitor_setup_table();

}

function monitor_config_arrays() {
	global $user_auth_realms, $user_auth_realm_filenames;
	$user_auth_realms[32]='View Monitoring';
	$user_auth_realm_filenames['monitor.php'] = 32;
}

function monitor_config_form() {
	global $fields_host_edit;
	$fields_host_edit2 = $fields_host_edit;
	$fields_host_edit3 = array();
	foreach ($fields_host_edit2 as $f => $a) {
		$fields_host_edit3[$f] = $a;
		if ($f == 'disabled') {
			$fields_host_edit3["monitor"] = array(
				"method" => "checkbox",
				"friendly_name" => "Monitor Host",
				"description" => "Check this box to monitor this host on the Monitor Tab.",
				"value" => "|arg1:monitor|",
				"default" => "",
				"form_id" => false
			);
		} 
	}
	$fields_host_edit = $fields_host_edit3;
}

function monitor_api_device_save($save) {
	if (isset($_POST['monitor']))
		$save["monitor"] = form_input_validate($_POST['monitor'], "monitor", "", true, 3);
	else
		$save['monitor'] = form_input_validate('', "monitor", "", true, 3);
	return $save;
}

function monitor_draw_navigation_text() {
	global $nav;
	$nav["monitor.php:"] = array("title" => "Monitoring", "mapping" => "index.php:", "url" => "monitor.php", "level" => "1");
}

function monitor_setup_table() {
	global $config, $database_default;
	include_once($config["library_path"] . "/database.php");
	$sql = "show columns from host from " . $database_default;
	$result = mysql_query($sql) or die (mysql_error());
	$found = false;
	while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
		if ($row['Field'] == 'monitor')
			$found = true;
	}
	if (!$found) {
		$sql = "alter table host add monitor char(3) default 'on' not null after disabled";
		$result = mysql_query($sql) or die (mysql_error());
	}
}

function monitor_version() {
	return array( 'name' 	=> 'monitor',
			'version' 	=> '0.1');
}

?>